<?php
/**
 * VMSynthDashboard
 * @author Nordmograph <contact@nordmograph.com>
 * @link https://www.nordmograph.com/extensions
 * @license GNU/GPL v3
**/
defined('_JEXEC') or die('Restricted access');
abstract class modVmSynthDashboardHelper
{
	static function getCurrency()
	{
		$db = JFactory::getDBO();
		$q ="SELECT vc.`currency_symbol` , vc.`currency_positive_style` , vc.`currency_decimal_place` , 
		vc.`currency_decimal_symbol` , vc.`currency_thousands` 
		FROM `#__virtuemart_currencies` vc 
		LEFT JOIN `#__virtuemart_vendors` vv ON vv.`vendor_currency` = vc.`virtuemart_currency_id` 
		WHERE vv.`virtuemart_vendor_id` ='1' " ;		
		$db->setQuery($q);
		$main_currency = $db->loadRow();
		return $main_currency;
	}
	
	static function getXMonthSells($params, $x)
	{
		$vmorderstates = $params->get('orderstates', array('C'));
		$orderstates = "";
		for( $i=0 ; $i < count($vmorderstates); $i++)
		{
			$orderstates .= "vo.`order_status`='".$vmorderstates[$i]."' ";
			if ( $i < (count($vmorderstates)-1) )
			{
				$orderstates .= "OR ";
			}
		}		
		$q_date = date("Y-m",strtotime(  "-".$x." month"  , strtotime(date('15 M Y')))   );
		$db = JFactory::getDBO();
		$q ="SELECT vo.`order_total` ,
		vu.`city` , vc.`country_name` 
		FROM `#__virtuemart_orders` vo 
		LEFT JOIN `#__virtuemart_order_userinfos` vu 
			ON vu.`virtuemart_order_id` = vo.`virtuemart_order_id` AND vu.`address_type`='BT'
		LEFT JOIN `#__virtuemart_countries` vc ON vu.`virtuemart_country_id` = vc.`virtuemart_country_id` 
		WHERE ( $orderstates ) 
		AND SUBSTRING(vo.`created_on`,1,7) = '".$q_date."'   " ;
		$db->setQuery($q);
		$xmonthorders = $db->loadObjectList();
		$x_month_total = 0;
		$orders_count =0;
		$monthsells_array = array();
		$cities = array();
		$countries = array();
		if( count($xmonthorders) >0)
		{
			foreach($xmonthorders as $xmonthorder)
			{
				$x_month_total = $x_month_total + $xmonthorder->order_total;
				$orders_count++;
				$cities[] = $xmonthorder->city;
				$countries[] = $xmonthorder->country_name;
			}
			$monthsells_array['x_month_total'] = $x_month_total;
			$monthsells_array['orders_count'] = $orders_count;
			$monthsells_array['cities'] = $cities;
			$monthsells_array['countries'] = $countries;
		}
		return $monthsells_array;
	}
	
	
	static function getXMonthRatio($params, $x )
	{
		$ratio_status1			= $params->get('ratio_status1','C');
		$ratio_status2			= $params->get('ratio_status2','P');	
		
		
		$q_date = date("Y-m",strtotime(  "-".$x." month"  , strtotime(date('15 M Y')))   );
		
		
		$db = JFactory::getDBO();
		$q ="SELECT 
			
			( SELECT COUNT(*) FROM `#__virtuemart_orders`  
			WHERE `order_status`='".$ratio_status2."' AND SUBSTRING(`created_on`,1,7) = '".$q_date."'  )
			/( SELECT COUNT(*) FROM `#__virtuemart_orders`  
			WHERE `order_status`='".$ratio_status1."' AND SUBSTRING(`created_on`,1,7) = '".$q_date."'  )
			AS ratio " ;
		$db->setQuery($q);
		$ratio = $db->loadResult();
		
		return $ratio;
	}

	static function getOrders($params)
	{
		$db		= JFactory::getDbo();
		$orders_limit = $params->get('orders_limit', '13');
		$q = "SELECT vo.`virtuemart_order_id` , vo.`virtuemart_user_id` , vo.`virtuemart_vendor_id` , 
		vo.`order_number` , vo.`order_total` , vo.`order_currency` , vo.`order_status` , vo.`created_on` , vo.`created_by` ,
		concat_ws(' ',vu.`first_name`,vu.`last_name`) AS custname , vu.`company` ,
		v.`created_by` ,
		vendor.`name` AS vendorname ,
		vos.`order_status_name` 
		FROM `#__virtuemart_orders` vo 
		LEFT JOIN `#__virtuemart_order_userinfos` vu ON vu.`virtuemart_order_id` = vo.`virtuemart_order_id` AND vu.`address_type`='BT'  
		LEFT JOIN `#__virtuemart_vendors` v ON v.`virtuemart_vendor_id` = vo.`virtuemart_vendor_id` 
		LEFT JOIN `#__users` AS vendor ON vendor.`id` = v.`created_by` 
		LEFT JOIN `#__virtuemart_orderstates` vos ON vos.`order_status_code` = vo.`order_status` 
		ORDER BY vo.`created_on` DESC
		LIMIT ".$orders_limit ;
		$db->setQuery($q);
		$orders = $db->loadObjectList();
		return $orders;	
	}
	
	static function getReviews($params)
	{
		$db		= JFactory::getDbo();
		$reviews_limit = $params->get('reviews_limit', '20');
		$langtag = JComponentHelper::getParams('com_languages')->get('site');
		$dblangtag 					= strtolower(str_replace('-','_',$langtag));
		$q = "SELECT vrr.`virtuemart_rating_review_id` , vrr.`virtuemart_product_id` , vrr.`comment` , 
		vrr.`review_rates` , vrr.`review_ratingcount` , vrr.`created_by` , vrr.`created_on` , vrr.`published` ,
		vpl.`product_name` , 
		u.`name` 
		FROM `#__virtuemart_rating_reviews`  vrr 
		LEFT JOIN `#__virtuemart_products_".$dblangtag."` vpl ON vpl.`virtuemart_product_id` = vrr.`virtuemart_product_id` 
		LEFT JOIN `#__users` u ON u.`id` = vrr.`created_by` 
		ORDER BY vrr.`published` ASC , vrr.`created_on` DESC
		LIMIT ".$reviews_limit ;
		$db->setQuery($q);
		$reviews = $db->loadObjectList();
		return $reviews;
	}
	static function getProducts($params)
	{
		$db		= JFactory::getDbo();
		$products_limit = $params->get('products_limit', '20');
		$langtag = JComponentHelper::getParams('com_languages')->get('site');
		$dblangtag 					= strtolower(str_replace('-','_',$langtag));
		$q = "SELECT DISTINCT(vpl.`virtuemart_product_id`) , vpl.`product_name` ,
		vp.`product_sku`, vp.`published` ,
		vpc.`virtuemart_category_id` ,
		vcl.`category_name`,
		vpp.`product_price` 
		FROM  `#__virtuemart_products_".$dblangtag."` vpl 
		LEFT JOIN `#__virtuemart_products` vp ON vp.`virtuemart_product_id` = vpl.`virtuemart_product_id` 
		LEFT JOIN `#__virtuemart_product_categories` vpc ON vpc.`virtuemart_product_id` = vpl.`virtuemart_product_id`  
		LEFT JOIN `#__virtuemart_categories_".$dblangtag."` vcl ON vcl.`virtuemart_category_id` = vpc.`virtuemart_category_id` 
		LEFT JOIN `#__virtuemart_product_prices` vpp ON vpp.`virtuemart_product_id` = vpl.`virtuemart_product_id` 
		GROUP BY vpl.`virtuemart_product_id` ORDER BY vpl.`virtuemart_product_id` DESC 
		LIMIT ".$products_limit ;
		$db->setQuery($q);
		$products = $db->loadObjectList();
		return $products;
	}
	static function getShoppers($params)
	{
		$db		= JFactory::getDbo();
		$shoppers_limit = $params->get('shoppers_limit', '20');
		$q = "SELECT vu.`virtuemart_user_id` , vu.`last_name`, 
		vu.`first_name`, vu.`company`  , vu.`created_on` ,
		u.`username` , u.`block` 
		FROM `#__virtuemart_userinfos` vu 
		LEFT JOIN `#__users` u ON u.`id` = vu.`virtuemart_user_id` 
		WHERE vu.`address_type`='BT' 
		ORDER BY vu.`virtuemart_userinfo_id` DESC
		LIMIT ".$shoppers_limit ;
		$db->setQuery($q);
		$shoppers = $db->loadObjectList();
		return $shoppers;
	}
	static function getReminded( $orderid )
	{
		$db		= JFactory::getDbo();
		$q = "SELECT reminded_on FROM #__unpaidreminder_revives WHERE order_id='".$orderid."' ";
		$db->setQUery($q);
		return $db->loadResult();
		
	}
}